<?php
namespace Teknisa\GOP\Modules\Cadastro\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification; 
use Teknisa\GOP\Modules\Cadastro\Services\Gop18000OrcamentoImpostoService;

class Gop18000OrcamentoImpostoController extends \Teknisa\GER\Controllers\TeknisaCrud {
    protected $connection;
    protected $dataSourceManager;

    
    public function __construct($crudService, ParameterBag $parameterBag, $connection, $dataSourceManager, Gop18000OrcamentoImpostoService $service) {
        $this->connection = $connection;
        $this->dataSourceManager    = $dataSourceManager;
        parent::__construct($crudService, $parameterBag);
        $this->service      = $service;
    }
    
    public function updateImposto(DTO\Request $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows();
        
        $backupRow = $rows[0];
        $currentRow = $rows[1];
        
        $currentRow['VRPERCSOBFAT']   = str_replace(",", ".", $currentRow['VRPERCSOBFAT']);
        $currentRow['VRPERCSOBCONS']  = str_replace(",", ".", $currentRow['VRPERCSOBCONS']);
        $currentRow['VRPERCSOBLUCRO'] = str_replace(",", ".", $currentRow['VRPERCSOBLUCRO']);
        
        $backupRow['VRPERCSOBFAT']    = str_replace(",", ".", $backupRow['VRPERCSOBFAT']);
        $backupRow['VRPERCSOBCONS']   = str_replace(",", ".", $backupRow['VRPERCSOBCONS']);
        $backupRow['VRPERCSOBLUCRO']  = str_replace(",", ".", $backupRow['VRPERCSOBLUCRO']);
        
        $params = array();
        $params['P_CDFILIAL']         = $currentRow['CDFILIAL'];                                 
        $params['P_CDIMPOSTO']        = $currentRow['CDIMPOSTO'];                                          
        $params['P_VRPERCSOBFAT']     = $currentRow['VRPERCSOBFAT'];     
        $params['P_VRPERCSOBCONS']    = $currentRow['VRPERCSOBCONS'];      
        $params['P_VRPERCSOBLUCRO']   = $currentRow['VRPERCSOBLUCRO'];
        $params['CDFILIAL']           = $backupRow['CDFILIAL'];                                 
        $params['CDIMPOSTO']          = $backupRow['CDIMPOSTO'];                                          
        $params['VRPERCSOBFAT']       = $backupRow['VRPERCSOBFAT'];     
        $params['VRPERCSOBCONS']      = $backupRow['VRPERCSOBCONS'];      
        $params['VRPERCSOBLUCRO']     = $backupRow['VRPERCSOBLUCRO'];
        
        $this->service->saveEdit($params);
    }
    
}